/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 **********************************************************************/

#ifdef USE_UI_GTK

#ifndef PIXMAP_GTK_HEADER
#define PIXMAP_GTK_HEADER

#include "../../basistypes.h"

namespace GTK_DOKO {
#include <gtk/gtkwidget.h>

  // the number of rotations (up, left, down, right)

  class Pixmap {
    public:
      static vector<Pixmap>& load_and_rotate(vector<Pixmap>& pixmap,
					     string const& filename);

    public:
      Pixmap();
      Pixmap(string const& filename, bool const errorout = true);
      Pixmap(Pixmap const&);
      Pixmap(GdkPixmap* pixmap_a, GdkBitmap* mask_a);
      Pixmap& operator=(Pixmap const&);

      ~Pixmap();

      GdkPixmap* pixmap() const;
      GdkBitmap* mask() const;
      unsigned width() const;
      unsigned height() const;

      bool is_transparent(unsigned const x, unsigned const y) const;

      GtkWidget* widget() const;

      operator bool() const;

      Pixmap& rotate(Rotation const rotation = RIGHT); // rotates the pixmap
      Pixmap rotated(Rotation const rotation = RIGHT) const; // returns a rotated version of the pixmap

      void draw(GdkDrawable* drawable,
		int const x, int const y);
      // draw the pixmap at the given position

    private: // functions
      void pixmap_rotate(Rotation const rotation = RIGHT);
      void mask_rotate(Rotation const rotation = RIGHT);

      void size_set();

    private: // variables
      GdkPixmap* pixmap_p;
      GdkBitmap* mask_p;
      unsigned width_p;
      unsigned height_p;
  }; // class Pixmap

} // namespace GTK_DOKO

#endif // #ifndef PIXMAP_GTK_HEADER
#endif // #ifdef USE_UI_GTK
